<?php

/* myarcadeplugin */

function custom_paths() {
    $base_path = import_get_session('base_path');
    $base_path = rtrim($base_path, '/');
    return array(
        'thumbs' => null, // $base_path . '/images',
        'files' => null, //$base_path . '/swfs',
        'avatars' => null, // $base_path . '/avatars',
    );
}

function custom_tables($link) {
    //files
    $data = $link->query("SHOW TABLES like '%_myarcadegames'")->exec();
    $abs_games_table = null;
    if ($data->found()) {
        $d = $data->current;
        $abs_games_table = current($d);
    }
    //links
    $data = $link->query("SHOW TABLES like '%_links'")->exec();
    $abs_links_table = null;
    if ($data->found()) {
        $d = $data->current;
        $abs_links_table = current($d);
    }
    //users
    $data = $link->query("SHOW TABLES like '%_users'")->exec();
    $abs_users_table = null;
    if ($data->found()) {
        $d = $data->current;
        $abs_users_table = current($d);
    }

    return array(
        'abs_games' => @$abs_games_table,
        'abs_categories' => null,
        'abs_members' => $abs_users_table,
        'abs_links' => $abs_links_table,
        'abs_games_tags' => null
    );
}

/* =============== Data =============== */

function custom_conversion_games($mydb, $data) {
    if (!is_array($data) || empty($data))
        return false;

    return array(
        'gid' => @$data['id'],
        'game_name' => @stripslashes($data['name']),
        'seo_title' => !empty($data['slug']) ? $data['slug'] : convert::seoText($data['name']),
        'game_categories' => fjoin(',', cats_to_ids($mydb, @$data['categories'])),
        'game_description' => @stripslashes($data['description']),
        'game_instruction' => @stripslashes($data['instructions']),
        'game_controls' => @stripslashes($data['controls']),
        'game_tags' => fjoin(',', tags_to_ids($mydb, $data['tags'])),
        'game_img' => @$data['thumbnail_url'],
        'featured_img' => null,
        'game_file' => @stripslashes($data['swf_url']),
        'game_width' => intval(@$data['width']),
        'game_height' => intval(@$data['height']),
        'game_adddate' => !is_numeric(@$data['created']) && !empty($data['created']) ? strtotime($data['created']) : $data['created'],
        'game_rating' => null,
        'game_votes' => null,
        'game_is_featured' => null,
        'game_source' => 'convert',
        'game_is_active' => ($data['status'] == 'published') ? 1 : -1,
    );
}

function custom_conversion_links($data) {
    if (!is_array($data) || empty($data))
        return false;
    return array(
        'id' => @$data['link_id'],
        'partner_title' => @$data['link_name'],
        'partner_url' => @$data['link_url'],
        'expire_date' => date("Y-m-d", strtotime('+1 years')),
        'link_type' => 1,
        'status' => @convert::to_bool($data['link_visible']) ? 1 : 0,
    );
}

function custom_conversion_members($data) {
    if (!is_array($data) || empty($data))
        return false;
    return array(
        'id' => @$data['ID'],
        'username' => @$data['user_login'],
        'password' => @$data['user_pass'],
        'email' => @$data['user_email'],
        'name' => @$data['display_name'],
        'avatar' => null,
        'group' => 2,
        'status' => 1,
    );
}

